## nlohmann-json3 3.10.2

=== debian/changelog ===
nlohmann-json3 (3.10.2-1) unstable; urgency=medium

  * Team upload (salsa.d.o namespace)
  * New upstream version 3.10.2
  * update copyright years
  * Update copyright file

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 07 Sep 2021 09:11:10 +0200
