## nlohmann-json3 3.10.5

=== debian/changelog ===
nlohmann-json3 (3.10.5-2) unstable; urgency=medium

  * Team upload (salsa.d.o namespace)
  * Stop installing html files, remove upstream

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 17 Jan 2022 13:43:55 +0100

nlohmann-json3 (3.10.5-1) unstable; urgency=medium

  * Team upload (salsa.d.o namespace)
  * Update watch file to v4
  * New upstream version 3.10.5
  * Update copyright years

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 17 Jan 2022 11:33:34 +0100

nlohmann-json3 (3.10.4-1) unstable; urgency=medium

  * New upstream version 3.10.4
  * Bump std-version to 4.6.0
  * Allow-stderror for new doctest deprecation warning (Closes: #994864)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 20 Oct 2021 16:38:01 +0200
